
   /**
    * AccountBean -- Base Account Bean
    * This class must extend
    * javax.ejb.SessionBean and implement
    * the methods in this interface as well as providing
    * the implementation of the business methods.
    *
    */

package ejbay.account;

import javax.ejb.*;

import java.io.Serializable;
import java.util.*;
import java.rmi.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.net.*;

public class AccountBean implements javax.ejb.SessionBean 
{  
    static final boolean verbose = true;
  
    private transient SessionContext ctx;
    private transient Properties props;
    
    // Implement the methods in the SessionBean
    // interface
    public void ejbActivate() {
	if (verbose)
	    System.out.println("ejbActivate called");
    }
    
    public void ejbRemove() {
	if (verbose)
	    System.out.println("ejbRemove called");
    }
    
    public void ejbPassivate() {
	if (verbose)
	    System.out.println("ejbPassivate called");
    }
    
    /**
     * Sets the session context.
     *
     * @param SessionContext
     */
    public void setSessionContext(SessionContext ctx) {    
	if (verbose)
	    System.out.println("setSessionContext called");
	this.ctx = ctx;
	props = ctx.getEnvironment();
    }
    
    /**
     * This method corresponds to the create method in
     * the home interface DemoHome.java. 
     * The parameter sets of the two methods are 
     * identical. When the client calls 
     * DemoHome.create(), the container allocates an 
     * instance of the EJBean and calls ejbCreate(). 
     */ 
    public void ejbCreate () {
	if (verbose)
	    System.out.println("ejbCreate called");
	/*Nothing special needs to be done here yet.
	  Perhaps later we could create a connection to the database here, and 
	  not reconnect everytime
	*/
    }
    
    /**
     * 
     * 
     */
 
    public void AcctCreate(UserObj user) throws java.rmi.RemoteException, IllegalArgumentException{
	if (verbose)
	    System.out.println("AcctCreate called");
	if(null == user)
	    throw new IllegalArgumentException();

	
    };

    public UserObj AcctView(String emailAdd)throws java.rmi.RemoteException, IllegalArgumentException{
	if (verbose)
        {
	    System.out.println("AcctView called");

        }
        
	if(null == emailAdd || emailAdd.equals(""))
	    throw new IllegalArgumentException();

	try
	    {
		ResultSet rs = DatabaseAccessor.query("select * from Users WHERE EmailAdd=\'" + emailAdd + "\'");
		while(rs.next())
		    {
			if(verbose){
			    System.out.print("UserId: " + rs.getString(1));
			    System.out.print(", EmailAdd: " + rs.getString(2));
			    System.out.print(", FirstName: " + rs.getString(3));
			    System.out.print(", LastName: " + rs.getString(4));
			    System.out.print(", Password: " + rs.getString(5));
			    System.out.print(", CredCardName: " + rs.getString(6));
			    System.out.print(", CreditCardNum: " + rs.getString(7));
			    System.out.println(", ccExpDate: " + rs.getString(8));
			}

			
			UserObj user = new UserObj(rs.getString(2),
						   rs.getString(3),
						   rs.getString(4),
						   rs.getString(5),
						   rs.getString(6),
						   rs.getString(7),
						   rs.getString(8));

			
			user.setUserID((new Integer(rs.getString(1))).intValue());
			return user;
		    }
	    }catch(Exception e){
		/*nothing found??? TODO: make this better*/
		if(verbose)
		    System.out.println("Database query failed, or no record found");
		return null;
	    }
	return null;
    };
   
}
