package ejbay.account;

import javax.naming.InitialContext;
import javax.naming.Context;
import javax.naming.NamingException;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.net.*;
import javax.sql.DataSource;


public class DatabaseAccessor {

    /* Queries the mySQL database using the provided string and returns
     * the result.
     *
     * @param sqlString The SQL query string to send the database
     * @return A ResultSet object containing the server's response
     */
    public static ResultSet query(String sqlString)
    {
	Connection con = null;
	ResultSet rs = null;
	Statement st = null;

	try {
	    Context jndiCntx = new InitialContext();
	    DataSource ds = (javax.sql.DataSource) jndiCntx.lookup("java:/DefaultDS");
	   
	    con = ds.getConnection();
	    st = con.createStatement();
	    rs = st.executeQuery(sqlString);

	} catch(Exception e) {
	    e.printStackTrace();
	    System.out.println("Exception: " + e.getMessage());
	} finally {
	    try {
		if(con != null)
		    con.close();
	    } catch(SQLException e) {}
	}
	
	return rs;
    }

}
